---
title: llarp::vpn::NetworkInterface
summary: a vpn network interface 

---

# llarp::vpn::NetworkInterface



a vpn network interface 


`#include <vpn.hpp>`

Inherited by [llarp::apple::VPNInterface](Classes/classllarp_1_1apple_1_1VPNInterface.md), [llarp::vpn::AndroidInterface](Classes/classllarp_1_1vpn_1_1AndroidInterface.md), [llarp::vpn::LinuxInterface](Classes/classllarp_1_1vpn_1_1LinuxInterface.md)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-networkinterface)**([InterfaceInfo](Classes/structllarp_1_1vpn_1_1InterfaceInfo.md) info) |
| | **[NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-networkinterface)**(const [NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md) & ) =delete |
| | **[NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-networkinterface)**([NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md) && ) =delete |
| virtual | **[~NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-~networkinterface)**() =default |
| virtual int | **[PollFD](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-pollfd)**() const =0<br>get pollable fd for reading  |
| virtual void | **[Start](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-start)**()<br>start any platform specific operations before running  |
| virtual void | **[Stop](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-stop)**()<br>stop operation and tear down anything that [Start()](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-start) set up.  |
| const [InterfaceInfo](Classes/structllarp_1_1vpn_1_1InterfaceInfo.md) & | **[Info](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-info)**() const |
| virtual [net::IPPacket](Classes/structllarp_1_1net_1_1IPPacket.md) | **[ReadNextPacket](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-readnextpacket)**() =0<br>read next ip packet, return an empty packet if there are none ready.  |
| virtual bool | **[WritePacket](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-writepacket)**([net::IPPacket](Classes/structllarp_1_1net_1_1IPPacket.md) pkt) =0<br>write a packet to the interface returns false if we dropped it  |
| virtual void | **[MaybeWakeUpperLayers](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-maybewakeupperlayers)**() const<br>idempotently wake up the upper layers as needed (platform dependant)  |

## Protected Attributes

|                | Name           |
| -------------- | -------------- |
| [InterfaceInfo](Classes/structllarp_1_1vpn_1_1InterfaceInfo.md) | **[m_Info](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#variable-m-info)**  |

## Public Functions Documentation

### function NetworkInterface

```cpp
inline NetworkInterface(
    InterfaceInfo info
)
```


### function NetworkInterface

```cpp
NetworkInterface(
    const NetworkInterface & 
) =delete
```


### function NetworkInterface

```cpp
NetworkInterface(
    NetworkInterface && 
) =delete
```


### function ~NetworkInterface

```cpp
virtual ~NetworkInterface() =default
```


### function PollFD

```cpp
virtual int PollFD() const =0
```

get pollable fd for reading 

**Reimplemented by**: [llarp::apple::VPNInterface::PollFD](Classes/classllarp_1_1apple_1_1VPNInterface.md#function-pollfd), [llarp::vpn::AndroidInterface::PollFD](Classes/classllarp_1_1vpn_1_1AndroidInterface.md#function-pollfd), [llarp::vpn::LinuxInterface::PollFD](Classes/classllarp_1_1vpn_1_1LinuxInterface.md#function-pollfd)


### function Start

```cpp
inline virtual void Start()
```

start any platform specific operations before running 

### function Stop

```cpp
inline virtual void Stop()
```

stop operation and tear down anything that [Start()](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-start) set up. 

### function Info

```cpp
inline const InterfaceInfo & Info() const
```


### function ReadNextPacket

```cpp
virtual net::IPPacket ReadNextPacket() =0
```

read next ip packet, return an empty packet if there are none ready. 

**Reimplemented by**: [llarp::apple::VPNInterface::ReadNextPacket](Classes/classllarp_1_1apple_1_1VPNInterface.md#function-readnextpacket), [llarp::vpn::AndroidInterface::ReadNextPacket](Classes/classllarp_1_1vpn_1_1AndroidInterface.md#function-readnextpacket), [llarp::vpn::LinuxInterface::ReadNextPacket](Classes/classllarp_1_1vpn_1_1LinuxInterface.md#function-readnextpacket)


### function WritePacket

```cpp
virtual bool WritePacket(
    net::IPPacket pkt
) =0
```

write a packet to the interface returns false if we dropped it 

**Reimplemented by**: [llarp::apple::VPNInterface::WritePacket](Classes/classllarp_1_1apple_1_1VPNInterface.md#function-writepacket), [llarp::vpn::AndroidInterface::WritePacket](Classes/classllarp_1_1vpn_1_1AndroidInterface.md#function-writepacket), [llarp::vpn::LinuxInterface::WritePacket](Classes/classllarp_1_1vpn_1_1LinuxInterface.md#function-writepacket)


### function MaybeWakeUpperLayers

```cpp
inline virtual void MaybeWakeUpperLayers() const
```

idempotently wake up the upper layers as needed (platform dependant) 

**Reimplemented by**: [llarp::apple::VPNInterface::MaybeWakeUpperLayers](Classes/classllarp_1_1apple_1_1VPNInterface.md#function-maybewakeupperlayers)


## Protected Attributes Documentation

### variable m_Info

```cpp
InterfaceInfo m_Info;
```


-------------------------------

Updated on 2022-09-01 at 16:07:59 +0000